//------------------------------------------------------------------------------
// <auto-generated>
//     This code was generated by a tool.
//     Runtime Version:4.0.30319.42000
//
//     Changes to this file may cause incorrect behavior and will be lost if
//     the code is regenerated.
// </auto-generated>
//------------------------------------------------------------------------------

namespace MonitoringClient.GatewayMonitoringService
{
    
    
    /// <summary>
    /// Denotes a feature that allows to monitor the communication to connected servers
    /// </summary>
    [Tecan.Sila2.SilaFeatureAttribute(true, "gateway")]
    [Tecan.Sila2.SilaIdentifierAttribute("GatewayMonitoringService")]
    [Tecan.Sila2.SilaDisplayNameAttribute("Gateway Monitoring Service")]
    public partial interface IGatewayMonitoringService
    {
        
        /// <summary>
        /// Listens to messages of servers that follow the specified pattern
        /// </summary>
        /// <param name="serverPattern">The pattern of the server UUID that is followed, can contain wildcards like *</param>
        [Tecan.Sila2.ObservableAttribute()]
        Tecan.Sila2.IIntermediateObservableCommand<GatewayMonitoringMessage> ListenToServerMessages(string serverPattern);
    }
    
    /// <summary>
    /// CommandState
    /// </summary>
    public enum CommandState
    {
        
        NotStarted,
        
        Running,
        
        FinishedWithErrors,
        
        FinishedSuccess,
    }
    
    public struct StateUpdate
    {
        
        private double _progress;
        
        private System.TimeSpan _estimatedRemainingTime;
        
        private CommandState _state;
        
        /// <summary>
        /// Initializes a new instance
        /// </summary>
        public StateUpdate(double progress, System.TimeSpan estimatedRemainingTime, CommandState state)
        {
            _progress = progress;
            _estimatedRemainingTime = estimatedRemainingTime;
            _state = state;
        }
        
        public double Progress
        {
            get
            {
                return _progress;
            }
        }
        
        public System.TimeSpan EstimatedRemainingTime
        {
            get
            {
                return _estimatedRemainingTime;
            }
        }
        
        public CommandState State
        {
            get
            {
                return _state;
            }
        }
    }
    
    /// <summary>
    /// MessageType
    /// </summary>
    public enum MessageType
    {
        
        CommandInvocation,
        
        PropertyRead,
        
        StateUpdate,
        
        IntermediateValue,
        
        CommandResponse,
    }
    
    public struct GatewayMonitoringMessage
    {
        
        private MessageType _type;
        
        private string _serverUuid;
        
        private string _identifier;
        
        private System.DateTimeOffset _time;
        
        private StateUpdate _stateUpdate;
        
        /// <summary>
        /// Initializes a new instance
        /// </summary>
        public GatewayMonitoringMessage(MessageType type, string serverUuid, string identifier, System.DateTimeOffset time, StateUpdate stateUpdate)
        {
            _type = type;
            _serverUuid = serverUuid;
            _identifier = identifier;
            _time = time;
            _stateUpdate = stateUpdate;
        }
        
        public MessageType Type
        {
            get
            {
                return _type;
            }
        }
        
        public string ServerUuid
        {
            get
            {
                return _serverUuid;
            }
        }
        
        public string Identifier
        {
            get
            {
                return _identifier;
            }
        }
        
        public System.DateTimeOffset Time
        {
            get
            {
                return _time;
            }
        }
        
        public StateUpdate StateUpdate
        {
            get
            {
                return _stateUpdate;
            }
        }
    }
}
